com.google.appengine.tools.admin

## Class AppAdminFactory

- java.lang.Object
- - com.google.appengine.tools.admin.AppAdminFactory

-     public class AppAdminFactory
      extends java.lang.Object

  Creates a new `AppAdmin` for a designated App Engine application.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `AppAdminFactory.ConnectOptions` The options used to connect to the remote App Engine administration server.
    `static interface` | `AppAdminFactory.PasswordPrompt` Callback that is invoked to prompt the user to enter a password.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AppAdminFactory()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `AppAdmin` | `createAppAdmin(AppAdminFactory.ConnectOptions options, Application app, java.io.PrintWriter errorWriter)` Creates a new `AppAdmin` that can be used to administer the designated App Engine application.
    `com.google.appengine.tools.admin.ApplicationProcessingOptions` | `getAppOptions()`
    `java.lang.Class<? extends com.google.appengine.tools.admin.AppVersionUpload>` | `getAppVersionUploadClass()`
    `void` | `setAllowAnyRuntime(boolean allowAnyRuntime)` Enables or disables validation of the runtime id provided by the user.
    `void` | `setAppVersionUploadClass(java.lang.Class<? extends com.google.appengine.tools.admin.AppVersionUpload> klass)` Sets the class used for uploading the application to the server.
    `void` | `setBatchMode(boolean flag)` Requests we do upload using batch *
    `void` | `setCallerUploadingDispatch(boolean b)` Sets whether caller will upload dispatch.xml.
    `void` | `setCompileJsps(boolean flag)` Requests that *.jsp files should be compiled into Java byte code, or if false should be left untouched.
    `void` | `setDefaultStagingOptions(StagingOptions opts)` Replaces the default staging options to this application options.
    `void` | `setFailOnPrecompilationError(boolean fail)` Enables or disables treating (repeated) precompilation errors as fatal when updating an application.
    `void` | `setIgnoreEndpointsFailures(boolean ignore)` Enables or disables ignoring Google Cloud Endpoints failures when updating an app.
    `void` | `setJavaCompiler(java.io.File javac)` Specifies the location of a javac executable, used when compiling JSPs.
    `void` | `setJavaExecutable(java.io.File java)` Specifies the location of a java executable, used when compiling JSPs.
    `void` | `setQuickstart(boolean enable)`
    `void` | `setRuntime(java.lang.String runtime)` Sets the runtime id to use in the generated app.yaml descriptor.
    `void` | `setStagingOptions(StagingOptions opts)` Replaces the staging options to this application options.
    `void` | `setUseAsyncQuickstart(boolean async)` Use the Async quickstart generator.
    `void` | `setUseJava8(boolean java8)` Deprecated. This method has not effect, and should not be used anymore.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AppAdminFactory

          public AppAdminFactory()

  - ### Method Detail

    - #### createAppAdmin

          public AppAdmin createAppAdmin(AppAdminFactory.ConnectOptions options,
                                         Application app,
                                         java.io.PrintWriter errorWriter)

      Creates a new `AppAdmin` that can be used to administer the designated App Engine application.
      Parameters:
        `options` - The options used to connect to the remote server. Must not be `null`.
        `app` - The application to be administered. May be `null`.
        `errorWriter` - A writer to which error logs can be written. The logs can be used for diagnosis if a failure occurs during operation. May be `null`.
      Returns:
        a not `null` AppAdmin

    - #### getAppOptions

          public com.google.appengine.tools.admin.ApplicationProcessingOptions getAppOptions()

    - #### getAppVersionUploadClass

          public java.lang.Class<? extends com.google.appengine.tools.admin.AppVersionUpload> getAppVersionUploadClass()

    - #### setAppVersionUploadClass

          public void setAppVersionUploadClass(java.lang.Class<? extends com.google.appengine.tools.admin.AppVersionUpload> klass)

      Sets the class used for uploading the application to the server. Should only be used for advanced customization of the upload process.

    - #### setJavaExecutable

          public void setJavaExecutable(java.io.File java)

      Specifies the location of a java executable, used when compiling JSPs. By default, the system property `java.home` is used to identify the currently-running JVM, and if that directory contains a file named `bin/java` (Unix) or `bin\\java.exe` (Windows), that is returned.
      Parameters:
        `java` - the Java executable to be used.

    - #### setJavaCompiler

          public void setJavaCompiler(java.io.File javac)

      Specifies the location of a javac executable, used when compiling JSPs. By default, the system property `java.home` is used to identify the currently-running JVM. If that pathname ends with "jre", then its parent is used instead as a hoped-for JDK root. If that directory contains a file named `bin/javac` (Unix) or `bin\\javac.exe` (Windows), that is returned.
      Parameters:
        `javac` - the Java compiler executable to be used.

    - #### setCompileJsps

          public void setCompileJsps(boolean flag)

      Requests that *.jsp files should be compiled into Java byte code, or if false should be left untouched.
      Parameters:
        `flag` - `true` to compile .jsp files

    - #### setDefaultStagingOptions

          public void setDefaultStagingOptions(StagingOptions opts)

      Replaces the default staging options to this application options.
      Parameters:
        `opts` - the new staging options

    - #### setStagingOptions

          public void setStagingOptions(StagingOptions opts)

      Replaces the staging options to this application options.
      Parameters:
        `opts` - the new staging options

    - #### setBatchMode

          public void setBatchMode(boolean flag)

      Requests we do upload using batch *
      Parameters:
        `flag` - `true` to use batch mode for upload

    - #### setUseAsyncQuickstart

          public void setUseAsyncQuickstart(boolean async)

      Use the Async quickstart generator.
      Parameters:
        `async` - `true` uses the async quickstart generator.

    - #### setUseJava8

          @Deprecated
          public void setUseJava8(boolean java8)

      Deprecated. This method has not effect, and should not be used anymore.
      Use Java8 and Jetty9.
      Parameters:
        `java8` - `true` uses Java8 with Jetty9.

    - #### setRuntime

          public void setRuntime(java.lang.String runtime)

      Sets the runtime id to use in the generated app.yaml descriptor.
      Parameters:
        `runtime` - the runtime id to use.

    - #### setAllowAnyRuntime

          public void setAllowAnyRuntime(boolean allowAnyRuntime)

      Enables or disables validation of the runtime id provided by the user.
      Parameters:
        `allowAnyRuntime` - `true` to allow an arbitrary runtime id value, `false` to validate it against the list of supported runtimes.

    - #### setFailOnPrecompilationError

          public void setFailOnPrecompilationError(boolean fail)

      Enables or disables treating (repeated) precompilation errors as fatal when updating an application.
      Parameters:
        `fail` - `true` to abort an update if precompilation fails, `false` to treat it as a warning and continue updating the application.

    - #### setIgnoreEndpointsFailures

          public void setIgnoreEndpointsFailures(boolean ignore)

      Enables or disables ignoring Google Cloud Endpoints failures when updating an app.
      Parameters:
        `ignore` - `true` to ignore errors updating the Endpoints configuration, `false` to allow them to abort the update.

    - #### setQuickstart

          public void setQuickstart(boolean enable)

    - #### setCallerUploadingDispatch

          public void setCallerUploadingDispatch(boolean b)

      Sets whether caller will upload dispatch.xml.